-- A2A Spitfire accusim

-- LUA Script V 1.8
-- Apr 2017
--
--
-- (C) Guenter Steiner/guenseli

-- ## System functions ###############

function InitVars ()
	-- uncomment to disable display
     -- AutopilotDisplayBlocked ()
     -- AutoDisplay = false
     -- RadFlaps_state = "close"
     DSP_MODE_two ()
      --open_door_when_onground ()
end

function InitDsp ()
    -- override default behavior
end

function Timer ()
    GearL = math.floor(ipc.readLvar("LandingGearL"))
    GearR = math.floor(ipc.readLvar("LandingGearR"))

    RadFlaps_val = round(ipc.readLvar("Eng1_RadiatorFlap"))
    if RadFlaps_val == 0 then
        RadFlaps_state = "clos"
    elseif RadFlaps_val == 20 then
        RadFlaps_state = "norm"
    elseif RadFlaps_val == 40 then
        RadFlaps_state = "1/4"
    elseif RadFlaps_val == 60 then
        RadFlaps_state = "2/4"
    elseif RadFlaps_val == 80 then
        RadFlaps_state = "3/4"
    elseif RadFlaps_val == 100 then
        RadFlaps_state = "full"
    end

    CoolTemp = round(ipc.readLvar("Eng1_CoolantTemp"))

    Gear_stateAll = round(ipc.readLvar("GearHandlePosition"))
    if Gear_stateAll == 0 then
        Gear_stateText = "up"
    else
        Gear_stateText = "dn"
    end
    a = ipc.readLvar('LGearSafeLamp')
    b = ipc.readLvar('LGearUpSafeLamp')
    Gstate = a + b
    if Gstate ~= 1 then
        SPIT_GearPosition_show ()
    else
        FLIGHT_INFO1 = 'GR RadF'
        FLIGHT_INFO2 = (Gear_stateText .. ' ' .. RadFlaps_state)
    end

    if CoolTemp <= 120 then
        Dsp4('CTp\\')
    else
        Dsp4('CTP\\')
    end
    DspC(CoolTemp)
end


-- ## Electrics #####################################

-- $$ Generator

function SPIT_Generator_on ()
    LVarSet = "L:Eng1_GeneratorSwitch"
    ipc.writeLvar(LVarSet, 1)
    DspShow('GEN', 'on')
end

function SPIT_Generator_off ()
    LVarSet = "L:Eng1_GeneratorSwitch"
    ipc.writeLvar(LVarSet, 0)
    DspShow('GEN', 'off')
end

function SPIT_Generator_toggle ()
    LVarSet = "L:Eng1_GeneratorSwitch"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_Generator_on()
    else
        SPIT_Generator_off()
    end
end

-- $$ APU

function SPIT_APU_on ()
    LVarSet = "L:APUSwitch"
    ipc.writeLvar(LVarSet, 1)
    ipc.writeLvar("L:SystemCondValueFSX", 1)
	ipc.writeLvar("L:SystemCondSelectFSX", 53)
	DspShow("APU", "on")
end

function SPIT_APU_off ()
    LVarSet = "L:APUSwitch"
    ipc.writeLvar(LVarSet, 0)
    ipc.writeLvar("L:SystemCondValueFSX", 0)
	ipc.writeLvar("L:SystemCondSelectFSX", 53)
	DspShow("APU", "off")
end

function SPIT_APU_toggle ()
    LVarSet = "L:APUSwitch"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_APU_on()
    else
        SPIT_APU_off()
    end
end

-- ## Prime and Start #####################################

-- $$ Primer

function SPIT_Primer_State_open ()
    LVarSet = "L:PrimerState"
    ipc.writeLvar(LVarSet, 1)
    SPIT_Primestate_show ()
end

function SPIT_Primer_State_closed ()
    LVarSet = "L:PrimerState"
    ipc.writeLvar(LVarSet, 0)
    SPIT_Primestate_show ()
end

function SPIT_Primer_State_toggle ()
    LVarSet = "L:PrimerState"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_Primer_State_open()
    else
        SPIT_Primer_State_closed()
    end
end

function SPIT_Primer_openandpull ()
    LVarSet = "L:PrimerState"
	if ipc.readLvar(LVarSet) == 0 then
    	ipc.writeLvar(LVarSet, 1)
        SPIT_Primestate_show ()
    	ipc.sleep(1300)
	end
	ipc.writeLvar(LVarSet, 2)
    SPIT_Primestate_show ()
end

function SPIT_Primestate_show ()
    LVarSet = "L:PrimerState"
    if _MCP1 () then
        if ipc.readLvar(LVarSet) == 0 then
            PrimText = "clos"
        elseif ipc.readLvar(LVarSet) == 1 then
            PrimText = "open"
        elseif ipc.readLvar(LVarSet) == 2 then
            PrimText = "pull"
        end
        DspShow("Prim", PrimText)
    elseif _MCP2 () or _MCP2a() then
        if ipc.readLvar(LVarSet) == 0 then
            PrimText = "closed"
        elseif ipc.readLvar(LVarSet) == 1 then
            PrimText = "open"
        elseif ipc.readLvar(LVarSet) == 2 then
            PrimText = "pull"
        end
        DspMed1("Primer")
        DspMed2(PrimText)
     end
end

-- $$ Starter

function SPIT_Starter_start ()
	ipc.writeLvar("L:Eng1_StarterSwitchLid", 1)
	ipc.sleep(200)
	ipc.writeLvar("L:Eng1_StarterSwitch", 1)
    DspShow("Strt", " on ")
end

function SPIT_Starter_stop ()
	ipc.writeLvar("L:Eng1_StarterSwitch", 0)
	ipc.sleep(500)
	ipc.writeLvar("L:Eng1_pStarterSwitchLid", 0)
	DspShow("Strt", "stop")
end

-- $$ Boost Cut Out

function SPIT_Boostcutout_off ()
    LVarSet = "L:BoostCutout"
    ipc.writeLvar(LVarSet, 1)
    DspShow('BCUT', 'off')
end

function SPIT_Boostcutout_on ()
    LVarSet = "L:BoostCutout"
    ipc.writeLvar(LVarSet, 0)
    DspShow('BCUT', 'on')
end

function SPIT_Boostcutout_toggle ()
    LVarSet = "L:BoostCutout"
    if ipc.readLvar(LVarSet) == 1 then
        SPIT_Boostcutout_on()
    else
        SPIT_Boostcutout_off()
    end
end

-- $$ Engine Cartridge Reload

function SPIT_Cartridge_Reload_or_Starting_Magneto ()
    acftname = ipc.readSTR("3D00", 35)
    if string.find(acftname,"Mk Ia",0,true) then
        LVarSet = "Eng1_StartingMagneto"
        val = 0
        MagText = " off"
        if ipc.readLvar(LVarSet) == 0 then
            val = 1
            MagText = " on "
        end
        ipc.writeLvar(LVarSet, val)
        if _MCP1() then
            DspShow("SMag", MagText)
        elseif _MCP2() or _MCP2a() then
            DspMed1("StartMagn")
            DspMed2(MagText)
        end
    else
        LVarSet = "L:Eng1_StarterCartridgeReloadSwitch"
        ipc.writeLvar(LVarSet, 1)
        CartVar = ipc.readLvar("L:Eng1_StarterCartridgeCount")
        if _MCP1() then
            DspShow("Cart", CartVar)
        elseif _MCP2() or _MCP2a() then
            DspMed1("CartRel")
            DspMed2(CartVar ..' left')
        end
    end
    --ipc.display(acftname)
    --ipc.sleep(2000)
end

function SPIT_StartCart_reload ()
    LVarSet = "L:Eng1_StarterCartridgeCount"
    ipc.writeLvar(LVarSet, 3)
    CartVar = ipc.readLvar(LVarSet)
    if _MCP1() then
        DspShow("Cart", CartVar)
    elseif _MCP2() or _MCP2a() then
        DspMed1("Carts")
        DspMed2(CartVar .. left)
    end
end


-- $$ Engine Cut Out

function SPIT_EngineCutOut_on ()
    LVarSet = "L:SlowRunningCutoutSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_EngineCutOut_off ()
    LVarSet = "L:SlowRunningCutoutSwitch"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_EngineCutOut_toggle ()
    LVarSet = "L:SlowRunningCutoutSwitch"
    val = 0
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_EngineCutOut_on()
    else
        SPIT_EngineCutOut_off()
    end
end

-- ## Fuel #####################################

-- $$ Mixture

function SPIT_Mixture_weak ()
    LVarSet = "L:MixtureRatioLever1Position"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Mixture_rich ()
    LVarSet = "L:MixtureRatioLever1Position"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Mixture_toggle ()
    LVarSet = "L:MixtureRatioLever1Position"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_Mixture_weak()
    else
        SPIT_Mixture_rich()
    end
end

-- $$ Fuel Selector - left

function SPIT_FuelTopState_show ()
    LVarSet = "L:FuelSelTop"
    FuelVar = ipc.readLvar(LVarSet)
    if FuelVar == 1 then
        FuelText = " on "
    elseif FuelVar == 0 then
        FuelText = " off"
    end
    if _MCP1() then
        DspShow("FTop", FuelText)
    elseif _MCP2() or _MCP2a() then
        DspMed1("Fuel Top")
        DspMed2(FuelText)
    end
end

function SPIT_FuelSelTop_on ()
    LVarSet = "L:FuelSelTop"
    ipc.writeLvar(LVarSet, 1)
    SPIT_FuelTopState_show ()
end

function SPIT_FuelSelTop_off ()
    LVarSet = "L:FuelSelTop"
    ipc.writeLvar(LVarSet, 0)
	SPIT_FuelTopState_show ()
end

function SPIT_FuelSelTop_toggle ()
    LVarSet = "L:FuelSelTop"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_FuelSelTop_on()
    else
        SPIT_FuelSelTop_off()
    end
end

-- $$ Fuel Selector- right

function SPIT_FuelBotState_show ()
    LVarSet = "L:FuelSelBott"
    FuelVar = ipc.readLvar(LVarSet)
    if FuelVar == 1 then
        FuelText = " on "
    elseif FuelVar == 0 then
        FuelText = " off"
    end
    if _MCP1() then
        DspShow("FBot", FuelText)
    elseif _MCP2() or _MCP2a() then
        DspMed1("FuelBott")
        DspMed2(FuelText)
    end
end

function SPIT_FuelSelBot_on ()
    LVarSet = "L:FuelSelBott"
    ipc.writeLvar(LVarSet, 1)
	SPIT_FuelBotState_show ()
end

function SPIT_FuelSelBot_off ()
    LVarSet = "L:FuelSelBott"
    ipc.writeLvar(LVarSet, 0)
	SPIT_FuelBotState_show ()
end

function SPIT_FuelSelBot_toggle ()
    LVarSet = "L:FuelSelBott"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_FuelSelBot_on()
    else
        SPIT_FuelSelBot_off()
    end
end

-- $$ Bottom tank

-- Bottom tank state for 5 seconds ON

function SPIT_FuelBott_show ()
    LVarSet = "L:FuelTankBott"
    FuelBott = round(ipc.readLvar(LVarSet)/1.20095042)
    DspShow("Bott", tostring(FuelBott) .. 'Ig')
end

function SPIT_BottTankstateTimer_on ()
	LVarSet = "L:BottTankOn"
	ipc.writeLvar(LVarSet, 1)
    SPIT_FuelBott_show ()
	ipc.sleep(4000)
    LVarSet = "L:BottTankOn"
	ipc.writeLvar(LVarSet, 0)
end

function SPIT_BottTankstate_on ()
	LVarSet = "L:BottTankOn"
	ipc.writeLvar(LVarSet, 1)
    SPIT_FuelBott_show ()
end

function SPIT_BottTankstate_off ()
	LVarSet = "L:BottTankOn"
	ipc.writeLvar(LVarSet, 0)
end

-------------------------------------------------------------- Top tank state

function SPIT_FuelTop_show ()
    LVarSet = "L:FuelTankTop"
    FuelTop = math.floor(ipc.readLvar(LVarSet)/1.20095042)
    DspShow(" Top", tostring(FuelTop) .. 'Ig')
end

-- Top tank state for 4 seconds ON

function SPIT_TopTankstateTimer_on ()
	LVarSet = "L:TopTankOn"
	ipc.writeLvar(LVarSet, 1)
    SPIT_FuelTop_show ()
	ipc.sleep(4000)
    LVarSet = "L:TopTankOn"
	ipc.writeLvar(LVarSet, 0)
end


function SPIT_TopTankstate_on ()
	LVarSet = "L:TopTankOn"
	ipc.writeLvar(LVarSet, 1)
    SPIT_FuelTop_show ()
end


function SPIT_TopTankstate_off ()
	LVarSet = "L:TopTankOn"
	ipc.writeLvar(LVarSet, 0)
end

-- ## Radiator Flap

function SPIT_RadFlap_show ()
    ipc.sleep(50)
    RadLevVar = ipc.readLvar("Eng1_RadiatorLeverPos")
    if RadLevVar == 0 then
    	RadLevTxt = "clos"
    elseif RadLevVar == 1 then
    	RadLevTxt = "norm"
    elseif RadLevVar == 2 then
    	RadLevTxt = "1/4"
    elseif RadLevVar == 3 then
    	RadLevTxt = "2/4"
    elseif RadLevVar == 4 then
    	RadLevTxt = "3/4"
    elseif RadLevVar == 5 then
    	RadLevTxt = "full"
    end
    DspShow ("RadF", RadLevTxt, "Radiator", RadLevTxt)
end

function SPIT_RadFlap_inc ()
    LVarSet = "L:Eng1_RadiatorLeverPos"
    val = ipc.readLvar(LVarSet)
    if val < 5 then
        val = val + 1
        ipc.writeLvar(LVarSet, val)
        ipc.sleep(50)
    end
    SPIT_RadFlap_show()
end

function SPIT_RadFlap_dec ()
    LVarSet = "L:Eng1_RadiatorLeverPos"
    val = ipc.readLvar(LVarSet)
    if val > 0 then
        val = val - 1
        ipc.writeLvar(LVarSet, val)
        ipc.sleep(50)
    end
    SPIT_RadFlap_show()
end

function SPIT_RadFlap_open ()
    LVarSet = "L:Eng1_RadiatorLeverPos"
    val = ipc.readLvar(LVarSet)
    if val < 5 then
        ipc.writeLvar(LVarSet, 5)
    end
    SPIT_RadFlap_show()
end

function SPIT_RadFlap_mid ()
    LVarSet = "L:Eng1_RadiatorLeverPos"
    val = ipc.readLvar(LVarSet)
    if val ~= 2 then
        ipc.writeLvar(LVarSet, 2)
    end
    SPIT_RadFlap_show()
end

function SPIT_RadFlap_close ()
    LVarSet = "L:Eng1_RadiatorLeverPos"
    val = ipc.readLvar(LVarSet)
    if val > 0 then
        ipc.writeLvar(LVarSet, 0)
    end
    SPIT_RadFlap_show()
end

-- ## Radiator Flap OLD ###################################

function RadiatorLever_show ()
    SPIT_RadFlap_show()
end

function RadiatorLever_clsd ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 0)
    SPIT_RadFlap_show()
end

function RadiatorLever_norm ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 1)
    SPIT_RadFlap_show()
end

function RadiatorLever_1_4 ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 2)
    SPIT_RadFlap_show()
end

function RadiatorLever_2_4 ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 3)
    SPIT_RadFlap_show()
end

function RadiatorLever_3_4 ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 4)
    SPIT_RadFlap_show()
end

function RadiatorLever_full ()
    ipc.writeLvar("Eng1_RadiatorLeverPos", 5)
    SPIT_RadFlap_show()
end

function RadiatorLever_inc ()
    SPIT_RadFlap_inc()
end

function RadiatorLever_dec ()
    SPIT_RadFlap_dec()
end


-- ## Lights #####################################

-- $$ Recognition Lights

function SPIT_Light_RecogVentral_on ()
    LVarSet = "L:LightRecogVentralSwitch"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Light_RecogVentral_off ()
    LVarSet = "L:LightRecogVentralSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Light_RecogVentral_morse ()
    LVarSet = "L:LightRecogVentralSwitch"
    ipc.writeLvar(LVarSet, 2)
end

----------------------------------------------

function SPIT_Light_RecogDorsal_on ()
    LVarSet = "L:LightRecogDorsalSwitch"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Light_RecogDorsal_off ()
    LVarSet = "L:LightRecogDorsalSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Light_RecogDorsal_morse ()
    LVarSet = "L:LightRecogDorsalSwitch"
    ipc.writeLvar(LVarSet, 2)
end

-- $$ Morse Key

function SPIT_morsekey ()
    LVarSet = "L:KeyMorseArm"
	ipc.writeLvar(LVarSet, 1)
	ipc.sleep(100)
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_morsekey_on ()
    LVarSet = "L:KeyMorseArm"
	ipc.writeLvar(LVarSet, 1)
end

function SPIT_morsekey_off ()
    LVarSet = "L:KeyMorseArm"
	ipc.writeLvar(LVarSet, 0)
end

-- $$ Landing Lights

function SPIT_Light_Land_extend ()
    LVarSet = "L:LandingLightExtendSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Light_Land_retract ()
    LVarSet = "L:LandingLightExtendSwitch"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Light_Land_toggle ()
    LVarSet = "L:LandingLightExtendSwitch"
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_Light_Land_extend()
    else
        SPIT_Light_Land_retract()
    end
end

----------------------------------------------

function SPIT_Light_Land_left ()
    LVarSet = "L:LandingLightSwitch"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Light_Land_off ()
    LVarSet = "L:LandingLightSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Light_Land_left_toggle ()
    LVarSet = "L:LandingLightSwitch"
    if ipc.readLvar(LVarSet) == 1 then
        SPIT_Light_Land_left()
    else
        SPIT_Light_Land_off()
    end
end

function SPIT_Light_Land_right ()
    LVarSet = "L:LandingLightSwitch"
    ipc.writeLvar(LVarSet, 2)
end

function SPIT_Light_Land_right_toggle ()
    LVarSet = "L:LandingLightSwitch"
    if ipc.readLvar(LVarSet) == 1 then
        SPIT_Light_Land_right()
    else
        SPIT_Light_Land_off()
    end
end

----------------------------------------------

function SPIT_Light_Land_left_Extend_on ()
    ipc.writeLvar("L:LandingLightExtendSwitch", 1)
	ipc.sleep(100)
    ipc.writeLvar("L:LandingLightSwitch", 0)
end

function SPIT_Light_Land_left_Retract_off ()
    ipc.writeLvar("L:LandingLightSwitch", 1)
	ipc.sleep(100)
    ipc.writeLvar("L:LandingLightExtendSwitch", 0)
end

function SPIT_Light_Land_right_Extend_on ()
    ipc.writeLvar("L:LandingLightExtendSwitch", 1)
	ipc.sleep(100)
    ipc.writeLvar("L:LandingLightSwitch", 2)
end

function SPIT_Light_Land_right_Retract_off ()
    ipc.writeLvar("L:LandingLightSwitch", 1)
	ipc.sleep(100)
    ipc.writeLvar("L:LandingLightExtendSwitch", 0)
end

-- $$ Landing Light Beam

function SPIT_Light_Land_Beam_up ()
	LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
	if val > 0 then
        val = val - 2
        ipc.writeLvar(LLBeam, val)
    	ipc.sleep(20)
	end
    SPIT_Light_LandBeam_show ()
end

function SPIT_Light_Land_Beam_down ()
    LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
    if val < 100 then
        val = val + 2
        ipc.writeLvar(LLBeam, val)
    	ipc.sleep(20)
	end
    SPIT_Light_LandBeam_show ()
end

function SPIT_Light_LandBeam_downfull ()
    LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
    if val < 100 then
    	ipc.writeLvar(LLBeam, 100)
	end
    SPIT_Light_LandBeam_show ()
end

function SPIT_Light_LandBeam_upfull ()
    LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
    if val > 0 then
    	ipc.writeLvar(LLBeam, 0)
	end
    SPIT_Light_LandBeam_show ()
end

function SPIT_Light_LandBeam_neutral ()
    LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
    if val ~= 50 then
    	ipc.writeLvar(LLBeam, 50)
	end
end

function SPIT_Light_LandBeam_show ()
	LLBeam = "L:LeverLandingLightBeam"
	val = ipc.readLvar(LLBeam)
    if _MCP1() then
        DspShow('BEAM', val)
    elseif _MCP2() or _MCP2a() then
        DspMed1("LL Beam")
        DspMed2(val)
    end
end

-- ## Defroster and Ventation #####################################

-- $$ Defrost

function SPIT_Defroster_on ()
	Def = "L:WindowDefrosterSwitch"
	ipc.writeLvar(Def, 1)
	SPIT_Defroster_show ()
end

function SPIT_Defroster_off ()
	Def = "L:WindowDefrosterSwitch"
	ipc.writeLvar(Def, 0)
	SPIT_Defroster_show ()
end

function SPIT_Defroster_inc ()
	Def = "L:WindowDefrosterControlKnob"
    val = ipc.readLvar(Def)
    if val < 100 then
        val = val + 5
	   ipc.writeLvar(Def, val)
       ipc.sleep(20)
    end
	SPIT_Defroster_show ()
end

function SPIT_Defroster_dec ()
	Def = "L:WindowDefrosterControlKnob"
    val = ipc.readLvar(Def)
    if val > 0 then
        val = val - 5
        ipc.writeLvar(Def, val)
        ipc.sleep(20)
    end
	SPIT_Defroster_show ()
end

function SPIT_Defroster_show ()
	Def = "L:WindowDefrosterSwitch" -- ControlKnob"
	val = ipc.readLvar(Def)
    if val == 0 then
        str = 'off'
    else
        str = 'on'
    end
    if _MCP1() then
        DspShow('DEFR', str)
    elseif _MCP2() or _MCP2a() then
        DspMed1("Defrost")
        DspMed2(str)
    end
end

-- $$ Cabin Vent

function SPIT_CabinVent_inc ()

	Def = "L:CabinVent"
	Var = ipc.readLvar(Def)

	if Var < 100 then
	Var = Var + 10
	ipc.sleep(50)
	end

	ipc.writeLvar(Def, Var)
	SPIT_CabinVent_show ()
end

function SPIT_CabinVent_dec ()
	Def = "L:CabinVent"
	Var = ipc.readLvar(Def)
	if Var > 0 then
	   Var = Var - 10
	   ipc.sleep(50)
	end
	ipc.writeLvar(Def, Var)
	SPIT_CabinVent_show ()
end


function SPIT_CabinVent_show ()
	Def = "L:CabinVent"
	Var = ipc.readLvar(Def)
	DspShow("VENT", Var)
end

-- ## Gunsight

function SPIT_Gunsight_on ()
    LVarSet = "L:GunSightSwitchOn"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Gunsight_off ()
    LVarSet = "L:GunSightSwitchOn"
    ipc.writeLvar(LVarSet, 0)
end

function SPIT_Gunsight_toggle ()
    LVarSet = "L:GunSightSwitchOn"
    val = 0
    if ipc.readLvar(LVarSet) == 0 then
        val = 1
    end
    ipc.writeLvar(LVarSet, val)
end

-- $$ Landing Gear

function SPIT_Gear_Horn_off ()
    LVarSet = "L:GearHornSilencerSwitch"
    ipc.writeLvar(LVarSet, 1)
end

function SPIT_Gear_up ()
   ipc.control(66079)
   DspShow("Gear", " up ")
end

function SPIT_Gear_down ()
   ipc.control(66080)
   DspShow("Gear", "down")
end

function SPIT_manual_gear_pump ()
    SPIT_Gear_pump_back ()
    ipc.sleep(10)
    SPIT_Gear_pump_fwd ()
end

function SPIT_Gear_pump_back ()
   DirVar1 = ipc.readLvar("HydrPumpManualLeverDirection")
   while DirVar1 == 0 do
		ipc.writeLvar("LandingGearPumpLever", 1)
   		DirVar1 = ipc.readLvar("HydrPumpManualLeverDirection")
   end
   ipc.writeLvar("LandingGearPumpLever", 0)
   SPIT_GearPosition_show ()
end

function SPIT_Gear_pump_fwd ()
   DirVar1 = ipc.readLvar("HydrPumpManualLeverDirection")
   while DirVar1 == 1 do
   ipc.writeLvar("LandingGearPumpLever", 1)
   DirVar1 = ipc.readLvar("HydrPumpManualLeverDirection")
   end
   ipc.writeLvar("LandingGearPumpLever", 0)
   SPIT_GearPosition_show ()
end

function SPIT_Automatic_Gear_Pump ()
   SPIT_Gear_AutoPump ()
end

function SPIT_Gear_AutoPump ()
    ipc.control(65852)
    i = 0
    GroundVal = ipc.readUW("0366")
    if GroundVal == 0 then
        while i ~= 1 do
            ipc.sleep(1000)
            a = ipc.readLvar('LGearSafeLamp')
            b = ipc.readLvar('LGearUpSafeLamp')
            i = a + b
            SPIT_GearPosition_show ()
        end
        ipc.control(65852)
    end
end

function SPIT_GearPosition_show ()
    GearL = math.floor(ipc.readLvar("LandingGearL"))
    GearR = math.floor(ipc.readLvar("LandingGearR"))
    GearEnd = GearL + GearR
    if GearEnd == 0 then
        GearState = '  up   '
    elseif GearEnd == 200 then
        GearState = ' down   '
    else
        GearState = 'L' .. tostring(GearL) .. ' R' .. tostring(GearR)
    end

    if _MCP1 () then
        DspShow('L' .. tostring(GearL), 'R' .. tostring(GearR))
    elseif _MCP2 () then
        DspMed1("GearPos")
        DspMed2(GearState)
    elseif _MCP2a() then
        DspMed1("GearPos")
        DspMed2(GearState)
    end
end

-- ## Oxygen #####################################

-- $$ Oxygen altitude

function SPIT_OXYAltSet_inc ()
	Oxy = "L:OxyAltSetValve"
	Var = ipc.readLvar(Oxy)
	if Var < 100 then
    	Var = Var + 2
	   ipc.sleep(1)
	end
    ipc.writeLvar(Oxy, Var)
	OXYAlt_show ()
end

function SPIT_OXYAltSet_dec ()
	Oxy = "L:OxyAltSetValve"
	Var = ipc.readLvar(Oxy)
	if Var > 0 then
        Var = Var - 2
        ipc.sleep(1)
	end
	ipc.writeLvar(Oxy, Var)
	SPIT_OXYAlt_show ()
end

function SPIT_OXYAlt_show ()
	OxyVar = "L:OxyAltSetValve"
	OxVar = ipc.readLvar(OxyVar)*5
    OxVar2 = ipc.readLvar(OxyVar)*0.5
    if _MCP1() then
    	DspShow("o2_A", OxVar)
    elseif _MCP2 () or _MCP2a() then
        DspMed1("Oxy Alt")
        DspMed2(OxVar2 .. '.000ft')
    end
end

-- $$ Oxygen Mask and Value

function SPIT_OXYMask_andValve_on ()
    if ipc.readLvar("L:OxyMaskOn") == 0 then
        ipc.writeLvar("L:OxyMaskOn", 1)
    end
    DspShow("Oxy", " on ")
    ipc.sleep(1000)
    if ipc.readLvar("L:OxyMaster") < 100 then
        i = 0
        while i <= 100 do
            ipc.writeLvar("L:OxyMaster", i)
            ipc.sleep(1)
            i = i + 10
            SPIT_OxyState_show ()
        end
    end
end

function SPIT_OXYMask_andValve_off ()
    if ipc.readLvar("L:OxyMaskOn") == 1 then
        ipc.writeLvar("L:OxyMaskOn", 0)
    end
    DspShow("Oxy", " off")
    ipc.sleep(1000)
    if ipc.readLvar("L:OxyMaster") > 0 then
        i = 100
        while i >= 0 do
            ipc.writeLvar("L:OxyMaster", i)
            ipc.sleep(1)
            i = i - 10
            SPIT_OxyState_show ()
        end
    end
end

function SPIT_OXYMask_andValve_toggle ()
	if _t("oxy") then
        SPIT_OXYMask_andValve_on ()
	else
        SPIT_OXYMask_andValve_off ()
	end
end

-- $$ Display functions

function SPIT_OxyState_show ()
    OxyState = ipc.readLvar("L:OxyMaster")
    --if LVarShow == 100 then OxyState = "on "
	--elseif LVarShow == 0 then OxyState = "off" end
	DspShow("OXY", OxyState)
end

-- ## Cockpit Canopy and Door #####################################

-- $$ Canopy

function SPIT_Canopy_open ()
    pos = ipc.readUB(0x3367)  -- get exit position
    if pos == 0 then
        ipc.control(66389,0)  -- toggle exit/canopy
        ipc.sleep(4000)
    end
    SPIT_Canopy_show()
end

function SPIT_Canopy_close ()
    LVarSet = 'CockpitSideDoor'
    pos = ipc.readUB(0x3367)
    if pos == 1 and ipc.readLvar(LVarSet) == 0 then
        ipc.control(66389,0)
        ipc.sleep(4000)
    end
    SPIT_Canopy_show()
end

function SPIT_Canopy_toggle ()
    LVarSet = 'CockpitSideDoor'
    pos = ipc.readUB(0x3367)
    if ipc.readLvar(LVarSet) == 0 then
        if pos == 1 then
            SPIT_Canopy_close ()
        else
            SPIT_Canopy_open ()
        end
    else
        SPIT_Canopy_show()
    end
end

function SPIT_Canopy_closeAll ()
    SPIT_Door_close ()
    SPIT_Canopy_close ()
end

function SPIT_Canopy_show ()
    pos = ipc.readUB(0x3367)
    if pos == 0 then
        val = 'shut'
    else
        val = 'open'
    end
    if _MCP1() then
        DspShow("Cnpy", val)
    elseif _MCP2() or _MCP2a() then
        DspMed1("Canopy")
        DspMed2(val)
    end
end

-- $$ Cockpit Side Door

function SPIT_Door_open ()
    LVarSet = 'CockpitSideDoor'
    val = ipc.readLvar(LVarSet)
    if val == 0 then
        ipc.writeLvar(LVarSet, 1)
        ipc.sleep(3000)
    end
    SPIT_Door_show()
end

function SPIT_Door_close ()
    LVarSet = 'CockpitSideDoor'
    val = ipc.readLvar(LVarSet)
    if val == 1 then
        ipc.writeLvar(LVarSet, 0)
        ipc.sleep(3000)
    end
    SPIT_Door_show ()
end

function SPIT_Door_toggle ()
    LVarSet = 'CockpitSideDoor'
    if ipc.readLvar(LVarSet) == 0 then
        SPIT_Door_open ()
    else
        SPIT_Door_close ()
    end
end

function SPIT_Door_show ()
    LVarSet = 'CockpitSideDoor'
    if ipc.readLvar(LVarSet) == 0 then
        val = "clos"
    else
        val = "open"
    end
    if _MCP1() then
        DspShow("Door", val)
    elseif _MCP2() or _MCP2a() then
        DspMed1("Door")
        DspMed2(val)
    end
end






